#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "gd.h"
#include "gdfontmb.h"
#include "cgi.h"


/* Geometry defines */
#define ROWh 16
#define ROWw 600
#define BARh 8
#define BARx 105
#define BARy ((ROWh-BARh)/2)
#define LM   4
#define TM   2
#define SIZx 100

#define FONT gdFontMediumBold
#define olour olor

#define LINEBUFLEN 255


typedef struct {
  void  * next;
  int   size;
  char  name[80];
} RECORD;

RECORD * head=NULL;
RECORD * tail=NULL;
int      numb=0;
int      redline=1024;
int      barscale=2;


void makegraph(char *file)
{
  gdImagePtr i;
  int bkgnd,black,white,hi,lo;
  int yoff,wd;
  RECORD * r;
  FILE *f;
  char sizestr[20];

  i=gdImageCreate(ROWw,ROWh*numb);
  if(i){
    bkgnd=gdImageColorAllocate(i,0,0,0);
    black=gdImageColorAllocate(i,0,0,0);
    white=gdImageColorAllocate(i,255,255,255);
    hi   =gdImageColorAllocate(i,222,0,0);
    lo   =gdImageColorAllocate(i,80,137,0);
    gdImageColorTransparent(i,bkgnd);
    gdImageInterlace(i,1);

    r=head;
    yoff=0;
    do {
     /* r->size;
      r->name; */

      gdImageString(i,FONT,LM,yoff+TM,r->name,black);

      if(r->size<1024)
        sprintf(sizestr,"%dK",r->size);
      else
        sprintf(sizestr,"%dM",r->size/1024);

      wd=FONT->w*strlen(sizestr);

      gdImageString(i,FONT,SIZx-wd,yoff+TM,sizestr,black);

      if(r->size>=redline){
        gdImageFilledRectangle(i,BARx,yoff+BARy,BARx+r->size/barscale,yoff+BARy+BARh,hi);
      }else
      {
        gdImageFilledRectangle(i,BARx,yoff+BARy,BARx+r->size/barscale,yoff+BARy+BARh,lo);
      }
      gdImageRectangle(i,BARx,yoff+BARy,BARx+r->size/barscale,yoff+BARy+BARh,black);

      yoff+=ROWh;
      r=r->next;
    }
    while (r);

    /* now save it */
    f=fopen(file,"wb");
    gdImageGif(i,f);
    fclose(f);
  }
}


RECORD * newrec(RECORD *l,int s,char*n)
{
  RECORD * r;
  r=(RECORD *)malloc(sizeof(RECORD));
  if(r){
    r->next=l;
    r->size=s;
    strcpy(r->name,n);
    }
  return r;
}

addrec(RECORD *r)
{
  if(head){
    /* not the first */
    tail->next=r;
    tail=r;
  }
  else
  {
    /* the first */
    head=tail=r;
  }
  numb++;
}

get_spc(char * dir)
{
  FILE *f;
  int r,size;
  char * name;
  RECORD * rec;
  char buf[LINEBUFLEN];

  strcpy(buf,"du -s ");
  strcat(buf,dir);
  strcat(buf,"/* > /tmp/du");
  /* r=system("du -s /home/* > /tmp/du" );*/
   r=system(buf);
  if(r){
    printf("System call returned %d\n",r);
    return;
  }
  f=fopen("/tmp/du","r+");
  if(f){
    while (fgets(buf,LINEBUFLEN,f)!=NULL){
       /* fputs(buf,stdout);*/
       size=atoi(buf);

       name=strstr(buf,"\n");
       if(name) *name=0;

       name=strstr(buf,dir);

       name+=strlen(dir)+1;

       rec=newrec(NULL,size,name);
       if(rec) addrec(rec);

       /* printf("%s %dK\n",name,size);*/
       }
    fclose(f);
    }
  else{
    puts("Unable to open temp file");
  }

}




cgi_main(cgi_info *ci) {
  char *parmval(form_entry *, char *);
  form_entry *parms, *p;
  form_entry *get_form_entries(cgi_info *);
  char *foo, *bar;
  char buf[LINEBUFLEN];

  print_mimeheader("text/html");

  puts("<HTML>\n");
  puts("<HEAD>\n");
  puts("<title>Account usage space graph</title>");
  puts("</HEAD>\n");
  puts("<BODY>\n");
  puts("<h1>Space utilisation graph</h1><P>");

  parms = get_form_entries(ci);
  if (parms) {
    /* extract specific form parameters */
    for(p=parms; p; p = p->next) {
      if (strcasecmp(p->name, "foo")) foo = p->val;
      else if (strcasecmp(p->name, "bar")) bar = p->val;
    }
  }

  switch(mcode(ci)) {

  case MCODE_HEAD:
    return;

  case MCODE_GET:
    get_spc("/home");
    makegraph("/usr/local/etc/cernhttpd/cgi-img/du.gif");

 /*   puts("Your GET response here");
    printf("based on foo=%s and bar=%s.\n", foo, bar);
*/

    printf("Space utilisation per user in %s <P>\n","/home");
    printf("<IMG SRC=\"/cgi-img/du.gif\" HIGHT=%d WIDTH=%d >\n",ROWh*numb,ROWw);
    puts("<P>\n");

    puts("<HR NOSHADE>\n");

    puts("<CENTER><FONT SIZE=-2><B>Generated by SpaceGraph 0.1 <BR>\n");
    puts("Copyright &#169 1996 Alan Williams.</B></FONT></CENTER>\n");

    puts("</BODY>\n");
    puts("</HTML>\n");





    break;

  case MCODE_POST:
    puts("Your POST response here");
    printf("based on foo=%s and bar=%s.\n", foo, bar);
    break;

  default:
    printf("Unrecognized method '%s'.\n", ci->request_method);
  }

  free_form_entries(parms);
}
