#include <stdio.h>
#include <sys/param.h>

int main()
{
  char buf[MAXHOSTNAMELEN+1];

  /* man gethostname
   * says that this is supported:
   *
   * NAME
   *   gethostname, sethostname - get/set name of current host
   *
   * SYNOPSIS
   *   gethostname(name, namelen)
   *   char *name;
   *   int namelen;
   *
   *   sethostname(name, namelen)
   *   char *name;
   *   int namelen;
   */


  /* So i do this... */
  
  gethostname(buf,MAXHOSTNAMELEN);
  
  /* and the compiler does this.. 
   *
   * $ cc test.c
   *   Undefined:
   *   _gethostname
   *   can't mix shared library and undefined symbols
   *
   */
  
  printf("Hostname is %s/n",buf);
  
  /* Interestingly the same call is documented in the RISC OS
   * TCP/IP programmers pack on page 58, without listing a
   * header file to include.  I can't find it documented in
   * the RISC iX PRM.
   *  
   * So how does the comand (where the hostname is 'archimedes') work?
   *  
   *   $ hostname
   *   archimedes
   *   $
   * 
   * manage to work.  The only trace I can find is in syscalls.h
   * which includes:
   *   #define SYS_gethostname 87
   *
   * At a guess this looks like an entry point for a kernel routine
   * so how would one call it?
   *
   */
}
