/*
 * $Header: /smsa/bsd:sys/SYSTEM/copyversion.c:bsd.riscix1_2  1.5  $
 * $Source: /smsa/bsd:sys/SYSTEM/copyversion.c: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 * $Desc$
 * $Log:	copyversion.c,v $
 * Revision 1.5  88/11/30  04:41:18  keith
 * Whoops, adb didnt like the funny user start addresses, so we go back to
 * the entry point being the real kernel start address. kern_exec now traps
 * this.
 * 
 * Revision 1.4  88/11/25  18:12:55  keith
 * Use "sscanf", it works better than "scanf".
 * 
 * Revision 1.3  88/11/25  04:14:48  keith
 * Fix3344: Modify the start address to correctly point at the code to tell
 * wally punters not to try to run /vmunix from a shell prompt.
 * 
 * Revision 1.2  88/09/27  16:16:09  keith
 * Fixed bug with missing & in second read call.  Also improved
 * diagnostic message somewhat.
 * 
 * Revision 1.1  88/09/21  03:06:23  keith
 * Initial version
 * 
 */

#if defined(TOOL_RCS) && !defined(lint)
static char RcsId[] = "$Header: /smsa/bsd:sys/SYSTEM/copyversion.c:bsd.riscix1_2  1.5  $";
#endif

#include <sys/types.h>
#include <sys/file.h>
#include <stdio.h>
#include <a.out.h>

struct nlist nl[] = {
  	{ "_version_info" } ,
 	{ 0 }
};

main(argc, argv)
     int argc;
     char *argv[];
{
	int loadaddress = 0x1000000;
	int f = open(argv[1], O_RDWR, 0);
	struct exec_header header;
	
	if (argc >= 3) {
		sscanf(argv[2], "%x", &loadaddress);
	}
	if (argc < 2)
		fatal("usage: copyversion kernel [ loadaddress ]");
	if (f < 0) {
		char buffer[1000];
		sprintf(buffer, "file '%s' not readable", argv[1]);
		fatal(buffer);
	}
	if (read(f, &header, sizeof(header)) != sizeof(header))
		fatal("cant read header");
	if (nlist(argv[1], nl) != 0)
		fatal("nlist: no symbol");
	if (lseek(f, nl[0].n_value - loadaddress + PAGESIZE, 0) < 0)
		fatal("lseek");
	if (read(f, &header.a_version, sizeof(header.a_version))
					 != sizeof(header.a_version))
		fatal("read info");
	if (lseek(f, 0, 0) < 0)
		fatal("lseek(f, 0, 0)");
	if (write(f, &header, sizeof(header)) != sizeof(header))
		fatal("write");
	close(f);
	exit(0);
}


fatal(s)
	char *s;
{
	fprintf(stderr, "copyversion: problem \"%s\"", s);
	perror("");
	exit(1);
}





