/*
 * $Header: /smsa/bsd:sys/include/arm/fp.h:bsd.riscix1_2  1.3  $
 * $Source: /smsa/bsd:sys/include/arm/fp.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 */

#ifndef	__arm_fp_h
#define	__arm_fp_h
#define	__machine_fp_h		"arm"

/* This structure contains the per-user floating point registers
 * it is saved on the stack during a signal delivery, or saved
 * into the u area as the FP resource is switched between processes.
 */
struct fp_regs {
	int	fp_status;
	struct	fp_reg {
		int first, second, third;
	} fp_reg[8];
};

/*
 * defines for various SYSID bytes
 */
#define SYSIDFPE	0x00			/* software emulator */
#define SYSIDFPPC	0x80			/* FPPC/WE32206 */
#define SYSIDFPA10	0x81			/* FPA10 */

#endif/*__arm_fp_h*/

/* EOF fp.h */
