/*
 * This file is part of the LIBCGI library
 *
 * Copyright 1994 by Enterprise Integration Technologies Corporation
 *
 * This is freeware with commercialization rights reserved; see the
 * LICENSE included in the distribution for specifics.
 */

#ifndef CGI_H
#define CGI_H

#define MCODE_GET 1
#define MCODE_POST 2
#define MCODE_PUT 3
#define MCODE_HEAD 4

typedef struct
{
  char *server_software;
  char *server_name;
  char *gateway_interface;
  char *server_protocol;
  char *server_port;
  char *request_method;
  char *http_accept;
  char *path_info;
  char *path_translated;
  char *script_name;
  char *query_string;
  char *remote_host;
  char *remote_addr;
  char *auth_type;
  char *remote_user;
  char *remote_ident;
  char *content_type;
  int content_length;
} cgi_info;

typedef struct festruct
{
  char *name;
  char *val;
  struct festruct *next;
} form_entry;




/* Prototypes */
/* ---------- */
char *parmval(form_entry *, char *);
form_entry *get_form_entries(cgi_info *);
void print_input_blank(char *, unsigned, unsigned, char *);
void print_sel_list(char *, char **, char *);
void print_submit(char *);
void print_doc_begin(char *);
char *trim(char *);
char *sanitize(char *, char *);
char *strmaxcpy(char *, char *, int);
int get_cgi_info(cgi_info *ci);
int syn_mimeheader(char *, char *);
int print_mimeheader(char *);
int syn_base_url(char *, cgi_info *);
int print_base_url(cgi_info *);
int mcode(cgi_info *);

#endif
