/*
 * $Header: /smsa/bsd:sys/SYSTEM/version.c:bsd.riscix1_2  1.4  $
 * $Source: /smsa/bsd:sys/SYSTEM/version.c: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 * $Desc$
 * $Log:	version.c,v $
 * Revision 1.4  89/10/18  11:19:13  keith
 * Major shuffling of the header files, which now occur in ../include/... and no .h
 * files remain in source directories. Header files must now be included by
 * '#include <XYZ/name.h>' where XYZ is a sub-directory. For parametric header
 * files from the build directory use '#include "name.h"'
 * 
 * Revision 1.3  89/09/28  12:32:53  keith
 * Slight modification to getversion so that the kernel version structure also
 * contains the kernel boot message.
 * The version_info structure contains both a version struct and the boot string,
 * hence there is no version_string, nor a versionlen;
 * 
 * Revision 1.2  88/09/21  11:20:42  keith
 * Change name of "version" to "version_string"
 * 
 * Revision 1.1  88/09/21  03:06:30  keith
 * Initial version
 * 
 */

#if defined(KERN_RCS) && !defined(lint)
static char RcsId[] = "$Header: /smsa/bsd:sys/SYSTEM/version.c:bsd.riscix1_2  1.4  $";
#endif

#include "../include/sys/version.h"

#ifndef OBJECTNUMBER
# define OBJECTNUMBER 0
# define OBJECTVERSION 1
#endif
#if OBJECTNUMBER > 1
	The -DOBJECTNUMBER must be 1 or 0
#endif
#ifndef OBJECTVERSION
#define OBJECTVERSION 1
#endif

struct kernel_version version_info = { { OBJECTNUMBER, OBJECTVERSION, RELEASENAME },
					 { VERSIONSTRING }
				     };
