/*
 * $Header: /smsa/bsd:sys/conf/sysconf.h:bsd.riscix1_2  1.8  $
 * $Source: /smsa/bsd:sys/conf/sysconf.h: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 * $Desc$
 * $Log:	sysconf.h,v $
 * Revision 1.8  89/06/21  08:13:16  mark
 * NPROC base count increased so NPROC is back to 50 for MAXUSERS=4.
 * 
 * Revision 1.7  89/06/10  10:10:11  mark
 * Substantially re-jigged for easier system tuning.  There is
 * now only one file (param.c) which includes this file, rather
 * than it being included implictly (via nested includes) in
 * practically every file in the system source tree.
 * 
 * Revision 1.6  89/05/23  14:10:42  mark
 * NCMAP reduced so that computation of ecmx allows the resultant
 * value to be stored as an unsigned char (in struct cmap fields
 * and cmhash[]).
 * 
 * Revision 1.5  88/10/26  11:04:25  brian
 * MAXSHLIBS added.
 * 
 * Revision 1.4  88/07/14  20:29:58  keith
 * Define NPROC to be unrelated to NUSERS at present
 * also NTEXT = NPROC since we rarely share text
 * 
 * Revision 1.3  88/06/17  20:21:28  beta
 * Acorn Unix initial beta version
 * 
 */
/* SYSTEM CONFIGURATION (SIZING) FILE */

#ifndef	TIMEZONE
#define	TIMEZONE	(0)
#endif	TIMEZONE

#ifndef	DST
#define	DST		(3)
#endif	DST

#ifndef	MAXUSERS
#define	MAXUSERS	4
#endif	MAXUSERS

#ifndef NMBUF
# define NMBUF (512)
#endif NMBUF

#define	NPROC		(18+8*MAXUSERS)
#define	NSWAPMAP	(NPROC*2)
#define	NBUF		(30)
#define	NSWBUF		(12)

/*
 * NCMAP: note: Some types in cmap.h, and the way ecmap is used
 * currently rely on this number being strictly less than 256.
 */
#define	NCMAP		(MAX_PHYS_PAGES-20)
#define	NFILE		(16*(NPROC+16+MAXUSERS)/10+32)
#define	NINODE		(NPROC+16+MAXUSERS+32)
#define	NCALLOUT	(16+NPROC)
#define	NTEXT		(36+MAXUSERS)
#define	NCLIST		(60+12*MAXUSERS)
#define	NCSIZE		(NPROC+16+MAXUSERS+32)

#ifdef	QUOTA
#define	NQUOTA		((MAXUSERS*9)/7+3)
#define	NDQUOT		(NINODE+(MAXUSERS*NMOUNT)/4)
#endif	QUOTA

