/*
 * $Header: /smsa/bsd:sys/net/sl_data.c:bsd.riscix1_2  1.2  $
 * $Source: /smsa/bsd:sys/net/sl_data.c: $
 *
 * Copyright (c) 1988 Acorn Computers Ltd., Cambridge, England
 *
 * $Desc$
 * $Log:	sl_data.c,v $
 * Revision 1.2  89/10/30  16:55:56  mark
 * Fixed for new-style <> #includes.  Moved "#if NSL > 0" so
 * that dependencies are independent of configuration.  sl_softc
 * is now the actual array rather than a pointer: this saves code
 * in the main SLIP module (if_sl.c).
 * 
 * Revision 1.1  89/10/06  16:50:44  mark
 * Initial revision
 * 
 */

/*
 * sl_data.c - declarations of structures for use by 
 * if_sl (Serial Line Internet Protocol) module.
 */

#include "lineconf.h"

#include <sys/param.h>
#include <sys/mbuf.h>
#include <sys/buf.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <sys/file.h>
#include <sys/tty.h>

#include <net/if.h>
#include <net/netisr.h>
#include <net/route.h>

#if INET
#include <netinet/in.h>
#include <netinet/in_systm.h>
#include <netinet/in_var.h>
#include <netinet/ip.h>
#endif

#include <net/sl_data.h>

#if NSL > 0

struct sl_softc sl_softc[NSL];

#endif/*NSL > 0*/

int n_sl = NSL;

/* EOF sl_data.c */
